import '@interactjs/auto-start';
import '@interactjs/auto-scroll';
import '@interactjs/actions/drag';
import '@interactjs/actions/resize';
import '@interactjs/modifiers';
import '@interactjs/dev-tools';
import { ICalcXy } from '@/core/interfaces/grid-item.interfaces';
export interface IGridItemProps {
    borderRadiusPx?: number;
    dragAllowFrom?: string | null;
    dragIgnoreFrom?: string;
    dragOption?: {
        [key: string]: any;
    };
    enableEditMode?: boolean;
    h: number;
    i: string | number;
    isBounded?: boolean | null;
    isDraggable?: boolean | null;
    isMirrored?: boolean | null;
    isResizable?: boolean | null;
    isStatic?: boolean | null;
    maxW?: number;
    maxH?: number;
    minH?: number;
    minW?: number;
    preserveAspectRatio?: boolean;
    resizeIgnoreFrom?: string | null;
    resizeOption?: {
        [key: string]: any;
    };
    showCloseButton?: boolean | null;
    useBorderRadius?: boolean | null;
    w: number;
    x: number;
    y: number;
}
declare const _default: __VLS_WithTemplateSlots<import("vue").DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<IGridItemProps>, {
    borderRadiusPx: number;
    dragAllowFrom: null;
    dragIgnoreFrom: string;
    dragOption: () => {};
    enableEditMode: boolean;
    i: string;
    isBounded: null;
    isDraggable: null;
    isMirrored: boolean;
    isResizable: null;
    isStatic: boolean;
    maxH: number;
    maxW: number;
    minH: number;
    minW: number;
    preserveAspectRatio: boolean;
    resizeIgnoreFrom: null;
    resizeOption: () => {};
    showCloseButton: boolean;
    useBorderRadius: boolean;
}>, {
    x: number;
    y: number;
    w: number;
    h: number;
    i: string | number;
    borderRadiusPx: number;
    dragAllowFrom: string | null;
    dragIgnoreFrom: string;
    dragOption: {
        [key: string]: any;
    };
    isBounded: boolean | null;
    isDraggable: boolean | null;
    isMirrored: boolean | null;
    isResizable: boolean | null;
    isStatic: boolean | null;
    maxW: number;
    maxH: number;
    minH: number;
    minW: number;
    resizeIgnoreFrom: string | null;
    resizeOption: {
        [key: string]: any;
    };
    showCloseButton: boolean | null;
    useBorderRadius: boolean | null;
    enableEditMode: boolean;
    preserveAspectRatio: boolean;
    autoSize: () => void;
    calcXY: (top: number, left: number) => ICalcXy;
    dragging: import("vue").Ref<{
        left?: number | undefined;
        right?: number | undefined;
        top: number;
        width: number;
        height: number;
    } | undefined>;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    "container-resized": (i: string | number, h: number, w: number, height: number, width: number) => void;
} & {
    move: (i: string | number, x: number, y: number) => void;
} & {
    moved: (i: string | number, x: number, y: number) => void;
} & {
    "remove-grid-item": (i: string | number) => void;
} & {
    resize: (i: string | number, h: number, w: number, height: number, width: number) => void;
} & {
    resized: (i: string | number, h: number, w: number, height: number, width: number) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<IGridItemProps>, {
    borderRadiusPx: number;
    dragAllowFrom: null;
    dragIgnoreFrom: string;
    dragOption: () => {};
    enableEditMode: boolean;
    i: string;
    isBounded: null;
    isDraggable: null;
    isMirrored: boolean;
    isResizable: null;
    isStatic: boolean;
    maxH: number;
    maxW: number;
    minH: number;
    minW: number;
    preserveAspectRatio: boolean;
    resizeIgnoreFrom: null;
    resizeOption: () => {};
    showCloseButton: boolean;
    useBorderRadius: boolean;
}>>> & {
    "onContainer-resized"?: ((i: string | number, h: number, w: number, height: number, width: number) => any) | undefined;
    onMove?: ((i: string | number, x: number, y: number) => any) | undefined;
    onMoved?: ((i: string | number, x: number, y: number) => any) | undefined;
    "onRemove-grid-item"?: ((i: string | number) => any) | undefined;
    onResize?: ((i: string | number, h: number, w: number, height: number, width: number) => any) | undefined;
    onResized?: ((i: string | number, h: number, w: number, height: number, width: number) => any) | undefined;
}, {
    i: string | number;
    borderRadiusPx: number;
    dragAllowFrom: string | null;
    dragIgnoreFrom: string;
    dragOption: {
        [key: string]: any;
    };
    enableEditMode: boolean;
    isBounded: boolean | null;
    isDraggable: boolean | null;
    isMirrored: boolean | null;
    isResizable: boolean | null;
    isStatic: boolean | null;
    maxW: number;
    maxH: number;
    minH: number;
    minW: number;
    preserveAspectRatio: boolean;
    resizeIgnoreFrom: string | null;
    resizeOption: {
        [key: string]: any;
    };
    showCloseButton: boolean | null;
    useBorderRadius: boolean | null;
}>, {
    default: (_: {
        style: any;
    }) => any;
}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? P[K] & {
        default: D[K];
    } : P[K];
};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
