import { EventType } from 'mitt';
import { IBreakpoints, IColumns } from './grid-layout-props.interface';
import { TLayout } from './layout-definition';
export interface IGridLayoutProps {
    autoSize?: boolean;
    borderRadiusPx?: number;
    breakpoints?: IBreakpoints;
    colNum?: number;
    cols?: IColumns;
    horizontalShift?: boolean;
    isBounded?: boolean;
    isDraggable?: boolean;
    isMirrored?: boolean;
    isResizable?: boolean;
    layout: TLayout;
    margin?: number[];
    maxRows?: number;
    preventCollision?: boolean;
    responsive?: boolean;
    responsiveLayouts?: {
        [key: string]: TLayout;
    };
    restoreOnDrag?: boolean;
    rowHeight?: number;
    showCloseButton?: boolean;
    transformScale?: number;
    useBorderRadius?: boolean;
    useCssTransforms?: boolean;
    verticalCompact?: boolean;
}
declare const _default: __VLS_WithTemplateSlots<import("vue").DefineComponent<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<IGridLayoutProps>, {
    autoSize: boolean;
    borderRadiusPx: number;
    breakpoints: () => IBreakpoints;
    colNum: number;
    cols: () => IColumns;
    horizontalShift: boolean;
    isBounded: boolean;
    isDraggable: boolean;
    isMirrored: boolean;
    isResizable: boolean;
    margin: () => number[];
    maxRows: number;
    preventCollision: boolean;
    responsive: boolean;
    responsiveLayouts: () => {};
    restoreOnDrag: boolean;
    rowHeight: number;
    showCloseButton: boolean;
    transformScale: number;
    useBorderRadius: boolean;
    useCssTransforms: boolean;
    verticalCompact: boolean;
}>, {
    defaultGridItem: import("vue").Ref<any>;
    dragEvent: (eventName?: EventType, id?: string | number, x?: number, y?: number, h?: number, w?: number) => void;
    erd: import("vue").Ref<{
        listenTo: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
        removeListener: (element: HTMLElement, callback: (elem: HTMLElement) => void) => void;
        removeAllListeners: (element: HTMLElement) => void;
        uninstall: (element: HTMLElement) => void;
    } | null>;
    isDragging: import("vue").Ref<boolean>;
    lastBreakpoint: import("vue").Ref<string | null>;
    lastLayoutLength: import("vue").Ref<number>;
    layouts: import("vue").Ref<{
        [key: string]: any;
    }>;
    mergeStyle: import("vue").Ref<{
        [key: string]: string;
    }>;
    originalLayout: import("vue").Ref<TLayout | undefined>;
    placeholder: import("vue").Ref<{
        x: number;
        y: number;
        w: number;
        h: number;
        i: string | number;
    }>;
    width: import("vue").Ref<number | null>;
    borderRadiusPx: number;
    cols: IColumns;
    colNum: number;
    rowHeight: number;
    margin: number[];
    maxRows: number;
    transformScale: number;
    breakpoints: IBreakpoints;
    layout: TLayout;
    responsiveLayouts: {
        [key: string]: TLayout;
    };
    isBounded: boolean;
    isDraggable: boolean;
    isMirrored: boolean;
    isResizable: boolean;
    showCloseButton: boolean;
    useBorderRadius: boolean;
    autoSize: boolean;
    responsive: boolean;
    horizontalShift: boolean;
    preventCollision: boolean;
    restoreOnDrag: boolean;
    useCssTransforms: boolean;
    verticalCompact: boolean;
}, unknown, {}, {}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    "layout-created": (layout: TLayout) => void;
} & {
    "layout-before-mount": (layout: TLayout) => void;
} & {
    "layout-mounted": (layout: TLayout) => void;
} & {
    "layout-updated": (layout: TLayout) => void;
} & {
    "layout-ready": (layout: TLayout) => void;
} & {
    "update:layout": (layout: TLayout) => void;
} & {
    "breakpoint-changed": (newBreakpoint: string, layout: TLayout) => void;
} & {
    "columns-changed": (colNum: number) => void;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<__VLS_WithDefaults<__VLS_TypePropsToRuntimeProps<IGridLayoutProps>, {
    autoSize: boolean;
    borderRadiusPx: number;
    breakpoints: () => IBreakpoints;
    colNum: number;
    cols: () => IColumns;
    horizontalShift: boolean;
    isBounded: boolean;
    isDraggable: boolean;
    isMirrored: boolean;
    isResizable: boolean;
    margin: () => number[];
    maxRows: number;
    preventCollision: boolean;
    responsive: boolean;
    responsiveLayouts: () => {};
    restoreOnDrag: boolean;
    rowHeight: number;
    showCloseButton: boolean;
    transformScale: number;
    useBorderRadius: boolean;
    useCssTransforms: boolean;
    verticalCompact: boolean;
}>>> & {
    "onBreakpoint-changed"?: ((newBreakpoint: string, layout: TLayout) => any) | undefined;
    "onColumns-changed"?: ((colNum: number) => any) | undefined;
    "onLayout-before-mount"?: ((layout: TLayout) => any) | undefined;
    "onLayout-created"?: ((layout: TLayout) => any) | undefined;
    "onLayout-mounted"?: ((layout: TLayout) => any) | undefined;
    "onLayout-ready"?: ((layout: TLayout) => any) | undefined;
    "onLayout-updated"?: ((layout: TLayout) => any) | undefined;
    "onUpdate:layout"?: ((layout: TLayout) => any) | undefined;
}, {
    borderRadiusPx: number;
    isBounded: boolean;
    isDraggable: boolean;
    isMirrored: boolean;
    isResizable: boolean;
    showCloseButton: boolean;
    useBorderRadius: boolean;
    autoSize: boolean;
    responsive: boolean;
    cols: IColumns;
    colNum: number;
    rowHeight: number;
    margin: number[];
    maxRows: number;
    transformScale: number;
    breakpoints: IBreakpoints;
    horizontalShift: boolean;
    preventCollision: boolean;
    responsiveLayouts: {
        [key: string]: TLayout;
    };
    restoreOnDrag: boolean;
    useCssTransforms: boolean;
    verticalCompact: boolean;
}>, {
    default: (_: {}) => any;
}>;
export default _default;
type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;
type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: import('vue').PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: import('vue').PropType<T[K]>;
        required: true;
    };
};
type __VLS_WithDefaults<P, D> = {
    [K in keyof Pick<P, keyof P>]: K extends keyof D ? P[K] & {
        default: D[K];
    } : P[K];
};
type __VLS_WithTemplateSlots<T, S> = T & {
    new (): {
        $slots: S;
    };
};
